# GalacticOptim.jl

GalacticOptim.jl is a package with a scope that is beyond your normal global optimization
package. GalacticOptim.jl seeks to bring together all of the optimization packages
it can find, local and global, into one unified Julia interface. This means, you
learn one package and you learn them all! GalacticOptim.jl adds a few high-level
features, such as integrating with automatic differentiation, to make its usage
fairly simple for most cases, while allowing all of the options in a single
unified interface.

##### Note: The package is still in active development.

## Installation

Assuming that you already have Julia correctly installed, it suffices to import
GalacticOptim.jl in the standard way:

```julia
import Pkg; Pkg.add("GalacticOptim")
```
The packages relevant to the core functionality of GalacticOptim.jl will be imported
accordingly and, in most cases, you do not have to worry about the manual
installation of dependencies. Below is the list of packages that need to be
installed explicitly if you intend to use the specific optimization algorithms
offered by them:

- [BlackBoxOptim.jl](https://github.com/robertfeldt/BlackBoxOptim.jl)
- [NLopt.jl](https://github.com/JuliaOpt/NLopt.jl)
- [MultistartOptimization.jl](https://github.com/tpapp/MultistartOptimization.jl)
- [QuadDIRECT.jl](https://github.com/timholy/QuadDIRECT.jl)
- [Evolutionary.jl](https://wildart.github.io/Evolutionary.jl/dev/)
- [CMAEvolutionStrategy.jl](https://github.com/jbrea/CMAEvolutionStrategy.jl)

The following optimization packages are included by default:

- [Flux.jl](https://fluxml.ai/)
- [Optim.jl](https://julianlsolvers.github.io/Optim.jl/stable/)
